]> git.ipfire.org Git - thirdparty/git.git/blob - git-sh-setup.sh
Reallow git-rebase --interactive --continue if commit is unnecessary
[thirdparty/git.git] / git-sh-setup.sh
1 #!/bin/sh
2 #
3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
6 # it dies.
7
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
11 # exporting it.
12 unset CDPATH
13
14 die() {
15 echo >&2 "$@"
16 exit 1
17 }
18
19 if test -n "$OPTIONS_SPEC"; then
20 usage() {
21 exec "$0" -h
22 }
23
24 parseopt_extra=
25 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
26 parseopt_extra="--keep-dashdash"
27
28 eval "$(
29 echo "$OPTIONS_SPEC" |
30 git rev-parse --parseopt $parseopt_extra -- "$@" ||
31 echo exit $?
32 )"
33 else
34 usage() {
35 die "Usage: $0 $USAGE"
36 }
37
38 if [ -z "$LONG_USAGE" ]
39 then
40 LONG_USAGE="Usage: $0 $USAGE"
41 else
42 LONG_USAGE="Usage: $0 $USAGE
43
44 $LONG_USAGE"
45 fi
46
47 case "$1" in
48 -h|--h|--he|--hel|--help)
49 echo "$LONG_USAGE"
50 exit
51 esac
52 fi
53
54 set_reflog_action() {
55 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
56 then
57 GIT_REFLOG_ACTION="$*"
58 export GIT_REFLOG_ACTION
59 fi
60 }
61
62 git_editor() {
63 : "${GIT_EDITOR:=$(git config core.editor)}"
64 : "${GIT_EDITOR:=${VISUAL:-${EDITOR}}}"
65 case "$GIT_EDITOR,$TERM" in
66 ,dumb)
67 echo >&2 "No editor specified in GIT_EDITOR, core.editor, VISUAL,"
68 echo >&2 "or EDITOR. Tried to fall back to vi but terminal is dumb."
69 echo >&2 "Please set one of these variables to an appropriate"
70 echo >&2 "editor or run $0 with options that will not cause an"
71 echo >&2 "editor to be invoked (e.g., -m or -F for git-commit)."
72 exit 1
73 ;;
74 esac
75 eval "${GIT_EDITOR:=vi}" '"$@"'
76 }
77
78 is_bare_repository () {
79 git rev-parse --is-bare-repository
80 }
81
82 cd_to_toplevel () {
83 cdup=$(git rev-parse --show-cdup)
84 if test ! -z "$cdup"
85 then
86 cd "$cdup" || {
87 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
88 exit 1
89 }
90 fi
91 }
92
93 require_work_tree () {
94 test $(git rev-parse --is-inside-work-tree) = true ||
95 die "fatal: $0 cannot be used without a working tree."
96 }
97
98 get_author_ident_from_commit () {
99 pick_author_script='
100 /^author /{
101 s/'\''/'\''\\'\'\''/g
102 h
103 s/^author \([^<]*\) <[^>]*> .*$/\1/
104 s/'\''/'\''\'\'\''/g
105 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
106
107 g
108 s/^author [^<]* <\([^>]*\)> .*$/\1/
109 s/'\''/'\''\'\'\''/g
110 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
111
112 g
113 s/^author [^<]* <[^>]*> \(.*\)$/\1/
114 s/'\''/'\''\'\'\''/g
115 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
116
117 q
118 }
119 '
120 encoding=$(git config i18n.commitencoding || echo UTF-8)
121 git show -s --pretty=raw --encoding="$encoding" "$1" |
122 LANG=C LC_ALL=C sed -ne "$pick_author_script"
123 }
124
125 # Make sure we are in a valid repository of a vintage we understand,
126 # if we require to be in a git repository.
127 if test -z "$NONGIT_OK"
128 then
129 if [ -z "$SUBDIRECTORY_OK" ]
130 then
131 : ${GIT_DIR=.git}
132 test -z "$(git rev-parse --show-cdup)" || {
133 exit=$?
134 echo >&2 "You need to run this command from the toplevel of the working tree."
135 exit $exit
136 }
137 else
138 GIT_DIR=$(git rev-parse --git-dir) || {
139 exit=$?
140 echo >&2 "Failed to find a valid git directory."
141 exit $exit
142 }
143 fi
144 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
145 echo >&2 "Unable to determine absolute path of git directory"
146 exit 1
147 }
148 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
149 fi